function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import ReactEchartsCore from 'echarts-for-react/lib/core';
import echarts from 'echarts/lib/echarts';
import 'echarts/lib/chart/line';
import 'echarts/lib/chart/lines';
import 'echarts/lib/component/legend';
import 'echarts/lib/component/legendScroll';
import 'echarts/lib/component/tooltip';
import 'echarts/lib/component/title';
import 'echarts/lib/component/markPoint';
import 'echarts/lib/component/markLine';
import 'echarts/lib/component/markArea';
import 'echarts/lib/component/dataZoom';
import { formatNumber } from '../utils'; // 节点处出现数据

var label = {
  show: true,
  position: 'top',
  textStyle: {
    color: '#000'
  }
};
var dataZoom = [{
  // 添加X轴滚动条
  realtime: true,
  show: true,
  start: 0,
  end: 60,
  height: 16 // handleSize: 8

}, {
  type: 'inside',
  realtime: true,
  start: 0,
  end: 60
}];
var LineChart = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var chartData = _ref.chartData,
      showTitle = _ref.showTitle,
      interval = _ref.interval,
      showLabel = _ref.showLabel,
      rest = _objectWithoutProperties(_ref, ["chartData", "showTitle", "interval", "showLabel"]);

  var option = {
    title: {
      text: chartData.title.text,
      show: showTitle,
      textStyle: {
        fontSize: 16,
        fontWeight: 500,
        color: 'rgba(0, 0, 0, 0.85)'
      }
    },
    tooltip: {
      trigger: 'axis' // axisPointer: {
      //   type: 'cross'
      // }

    },
    legend: {
      left: 4,
      top: showTitle ? 27 : 'top',
      type: 'scroll',
      icon: 'roundRect',
      padding: 0,
      itemHeight: 2,
      itemWidth: 12
    },
    toolbox: {
      show: false
    },
    grid: {
      top: showTitle || showLabel ? 66 : 36,
      left: 0,
      right: 10,
      bottom: 0,
      containLabel: true
    },
    xAxis: {
      type: 'category',
      axisLine: {
        lineStyle: {
          color: '#ccd6eb'
        }
      },
      axisLabel: {
        interval: interval ? 'auto' : 0
      },
      boundaryGap: true,
      data: chartData.xAxis[0].data
    },
    yAxis: {
      type: 'value',
      minInterval: 1,
      axisLine: {
        show: false
      },
      splitLine: {
        show: true,
        lineStyle: {
          type: 'dashed'
        }
      },
      axisTick: {
        show: false
      }
    },
    series: chartData.series || []
  };
  var targetArr = [];
  option.series.forEach(function (item) {
    if (showLabel) {
      item.label = _objectSpread(_objectSpread({}, label), {}, {
        formatter: chartData.isRate ? '{c}%' : function (_ref2) {
          var value = _ref2.value;
          // 千分位分隔符
          return "".concat(formatNumber(value));
        }
      });
    }

    item.type = 'line'; // item.symbol = "none" // 此处配置 不显示点
    // item.areaStyle={}

    targetArr = targetArr.concat(item.data);
  });

  if (chartData.xAxis[0].data.length > 25) {
    option.dataZoom = dataZoom;
  } else {
    option.dataZoom = [];
  }

  if (!targetArr.length) {
    // 数据为空时展示
    option.yAxis.max = 5000000;
    option.yAxis.min = 0;
  } else {
    option.yAxis.max = null;
    option.yAxis.min = null;
  }

  return /*#__PURE__*/React.createElement(ReactEchartsCore, _extends({
    echarts: echarts,
    notMerge: true,
    option: option,
    ref: ref
  }, rest));
});
LineChart.propTypes = {
  theme: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  interval: PropTypes.bool,
  showTitle: PropTypes.bool,
  showLabel: PropTypes.bool,
  style: PropTypes.object,
  className: PropTypes.string,
  chartData: PropTypes.object
};
LineChart.defaultProps = {
  style: {},
  classname: '',
  theme: 'macarons',
  showTitle: false,
  interval: true,
  showLabel: false,
  chartData: {
    title: {
      text: ''
    },
    series: [{
      data: [],
      type: 'line'
    }],
    xAxis: [{
      data: []
    }]
  }
};
export default LineChart;