function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef } from 'react';
import Empty from './Empty';
import PropTypes from 'prop-types';
import ReactEchartsCore from 'echarts-for-react/lib/core';
import echarts from 'echarts/lib/echarts';
import 'echarts/lib/chart/pie';
import 'echarts/lib/component/legend';
import 'echarts/lib/component/legendScroll';
import 'echarts/lib/component/tooltip';
import 'echarts/lib/component/title';
import 'echarts/lib/component/markPoint';
import 'echarts/lib/component/markLine';
import 'echarts/lib/component/markArea';
import 'echarts/lib/component/dataZoom';
var PieChart = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var chartData = _ref.chartData,
      radius = _ref.radius,
      showTitle = _ref.showTitle,
      rest = _objectWithoutProperties(_ref, ["chartData", "radius", "showTitle"]);

  var option = {
    title: {
      text: chartData.title.text,
      show: showTitle
    },
    tooltip: {
      trigger: 'item',
      formatter: '{a} <br/>{b}: {c} ({d}%)'
    },
    legend: {
      top: 'bottom',
      type: 'scroll'
    },
    toolbox: {
      show: false
    },
    series: [{
      name: chartData.series.length ? chartData.series[0].name : '',
      type: 'pie',
      radius: radius,
      selectedMode: 'single',
      // center: ['50%', '60%'],
      data: chartData.series.length ? chartData.series[0].data : [],
      label: {
        formatter: '{b} {d}% \n',
        padding: [0, 0]
      }
    }]
  };

  if (!chartData.series.length) {
    return /*#__PURE__*/React.createElement(Empty, {
      image: Empty.PRESENTED_IMAGE_SIMPLE
    });
  }

  return /*#__PURE__*/React.createElement(ReactEchartsCore, _extends({
    echarts: echarts,
    notMerge: true,
    ref: ref,
    option: option
  }, rest));
});
PieChart.propTypes = {
  theme: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  radius: PropTypes.array,
  showTitle: PropTypes.bool,
  style: PropTypes.object,
  className: PropTypes.string,
  chartData: PropTypes.object
};
PieChart.defaultProps = {
  style: {},
  classname: '',
  theme: 'macarons',
  showTitle: false,
  radius: ['35%', '50%'],
  chartData: {
    title: {
      text: ''
    },
    series: [{
      data: []
    }]
  }
};
export default PieChart;