"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = _interopRequireDefault(require("echarts-for-react/lib/core"));

var _echarts = _interopRequireDefault(require("echarts/lib/echarts"));

require("echarts/lib/chart/line");

require("echarts/lib/chart/lines");

require("echarts/lib/component/legend");

require("echarts/lib/component/legendScroll");

require("echarts/lib/component/tooltip");

require("echarts/lib/component/title");

require("echarts/lib/component/markPoint");

require("echarts/lib/component/markLine");

require("echarts/lib/component/markArea");

require("echarts/lib/component/dataZoom");

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// 节点处出现数据
var label = {
  show: true,
  position: 'top',
  textStyle: {
    color: '#000'
  }
};
var dataZoom = [{
  // 添加X轴滚动条
  realtime: true,
  show: true,
  start: 0,
  end: 60,
  height: 16 // handleSize: 8

}, {
  type: 'inside',
  realtime: true,
  start: 0,
  end: 60
}];
var LineChart = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, ref) {
  var chartData = _ref.chartData,
      showTitle = _ref.showTitle,
      interval = _ref.interval,
      showLabel = _ref.showLabel,
      rest = _objectWithoutProperties(_ref, ["chartData", "showTitle", "interval", "showLabel"]);

  var option = {
    title: {
      text: chartData.title.text,
      show: showTitle,
      textStyle: {
        fontSize: 16,
        fontWeight: 500,
        color: 'rgba(0, 0, 0, 0.85)'
      }
    },
    tooltip: {
      trigger: 'axis' // axisPointer: {
      //   type: 'cross'
      // }

    },
    legend: {
      left: 4,
      top: showTitle ? 27 : 'top',
      type: 'scroll',
      icon: 'roundRect',
      padding: 0,
      itemHeight: 2,
      itemWidth: 12
    },
    toolbox: {
      show: false
    },
    grid: {
      top: showTitle || showLabel ? 66 : 36,
      left: 0,
      right: 10,
      bottom: 0,
      containLabel: true
    },
    xAxis: {
      type: 'category',
      axisLine: {
        lineStyle: {
          color: '#ccd6eb'
        }
      },
      axisLabel: {
        interval: interval ? 'auto' : 0
      },
      boundaryGap: true,
      data: chartData.xAxis[0].data
    },
    yAxis: {
      type: 'value',
      minInterval: 1,
      axisLine: {
        show: false
      },
      splitLine: {
        show: true,
        lineStyle: {
          type: 'dashed'
        }
      },
      axisTick: {
        show: false
      }
    },
    series: chartData.series || []
  };
  var targetArr = [];
  option.series.forEach(function (item) {
    if (showLabel) {
      item.label = _objectSpread(_objectSpread({}, label), {}, {
        formatter: chartData.isRate ? '{c}%' : function (_ref2) {
          var value = _ref2.value;
          // 千分位分隔符
          return "".concat((0, _utils.formatNumber)(value));
        }
      });
    }

    item.type = 'line'; // item.symbol = "none" // 此处配置 不显示点
    // item.areaStyle={}

    targetArr = targetArr.concat(item.data);
  });

  if (chartData.xAxis[0].data.length > 25) {
    option.dataZoom = dataZoom;
  } else {
    option.dataZoom = [];
  }

  if (!targetArr.length) {
    // 数据为空时展示
    option.yAxis.max = 5000000;
    option.yAxis.min = 0;
  } else {
    option.yAxis.max = null;
    option.yAxis.min = null;
  }

  return /*#__PURE__*/_react["default"].createElement(_core["default"], _extends({
    echarts: _echarts["default"],
    notMerge: true,
    option: option,
    ref: ref
  }, rest));
});
LineChart.propTypes = {
  theme: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  interval: _propTypes["default"].bool,
  showTitle: _propTypes["default"].bool,
  showLabel: _propTypes["default"].bool,
  style: _propTypes["default"].object,
  className: _propTypes["default"].string,
  chartData: _propTypes["default"].object
};
LineChart.defaultProps = {
  style: {},
  classname: '',
  theme: 'macarons',
  showTitle: false,
  interval: true,
  showLabel: false,
  chartData: {
    title: {
      text: ''
    },
    series: [{
      data: [],
      type: 'line'
    }],
    xAxis: [{
      data: []
    }]
  }
};
var _default = LineChart;
exports["default"] = _default;