"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Empty = _interopRequireDefault(require("./Empty"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = _interopRequireDefault(require("echarts-for-react/lib/core"));

var _echarts = _interopRequireDefault(require("echarts/lib/echarts"));

require("echarts/lib/chart/pie");

require("echarts/lib/component/legend");

require("echarts/lib/component/legendScroll");

require("echarts/lib/component/tooltip");

require("echarts/lib/component/title");

require("echarts/lib/component/markPoint");

require("echarts/lib/component/markLine");

require("echarts/lib/component/markArea");

require("echarts/lib/component/dataZoom");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var PieChart = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, ref) {
  var chartData = _ref.chartData,
      radius = _ref.radius,
      showTitle = _ref.showTitle,
      rest = _objectWithoutProperties(_ref, ["chartData", "radius", "showTitle"]);

  var option = {
    title: {
      text: chartData.title.text,
      show: showTitle
    },
    tooltip: {
      trigger: 'item',
      formatter: '{a} <br/>{b}: {c} ({d}%)'
    },
    legend: {
      top: 'bottom',
      type: 'scroll'
    },
    toolbox: {
      show: false
    },
    series: [{
      name: chartData.series.length ? chartData.series[0].name : '',
      type: 'pie',
      radius: radius,
      selectedMode: 'single',
      // center: ['50%', '60%'],
      data: chartData.series.length ? chartData.series[0].data : [],
      label: {
        formatter: '{b} {d}% \n',
        padding: [0, 0]
      }
    }]
  };

  if (!chartData.series.length) {
    return /*#__PURE__*/_react["default"].createElement(_Empty["default"], {
      image: _Empty["default"].PRESENTED_IMAGE_SIMPLE
    });
  }

  return /*#__PURE__*/_react["default"].createElement(_core["default"], _extends({
    echarts: _echarts["default"],
    notMerge: true,
    ref: ref,
    option: option
  }, rest));
});
PieChart.propTypes = {
  theme: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  radius: _propTypes["default"].array,
  showTitle: _propTypes["default"].bool,
  style: _propTypes["default"].object,
  className: _propTypes["default"].string,
  chartData: _propTypes["default"].object
};
PieChart.defaultProps = {
  style: {},
  classname: '',
  theme: 'macarons',
  showTitle: false,
  radius: ['35%', '50%'],
  chartData: {
    title: {
      text: ''
    },
    series: [{
      data: []
    }]
  }
};
var _default = PieChart;
exports["default"] = _default;