"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Empty = _interopRequireDefault(require("./Empty"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = _interopRequireDefault(require("echarts-for-react/lib/core"));

var _echarts = _interopRequireDefault(require("echarts/lib/echarts"));

require("echarts/lib/chart/pie");

require("echarts/lib/component/legend");

require("echarts/lib/component/legendScroll");

require("echarts/lib/component/tooltip");

require("echarts/lib/component/title");

require("echarts/lib/component/markPoint");

require("echarts/lib/component/markLine");

require("echarts/lib/component/markArea");

require("echarts/lib/component/dataZoom");

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var index = 0; // 高亮索引

var PieChart = function PieChart(_ref) {
  var _legend;

  var chartData = _ref.chartData,
      radius = _ref.radius,
      showTitle = _ref.showTitle,
      rest = _objectWithoutProperties(_ref, ["chartData", "radius", "showTitle"]);

  var pieRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    var pieInstance = pieRef.current.getEchartsInstance();
    console.log('index', index);
    pieInstance.dispatchAction({
      type: 'highlight',
      seriesIndex: index,
      dataIndex: index
    });
    pieInstance.on('mouseover', function (e) {
      if (e.dataIndex != index) {
        this.dispatchAction({
          type: 'downplay',
          seriesIndex: 0,
          dataIndex: index
        });
      } else {
        this.dispatchAction({
          type: 'downplay',
          seriesIndex: 0,
          dataIndex: 0
        });
      }
    });
    pieInstance.on('mouseout', function (e) {
      index = e.dataIndex;
      this.dispatchAction({
        type: 'highlight',
        seriesIndex: 0,
        dataIndex: e.dataIndex
      });
    });
    return function () {
      pieInstance.off('mouseover');
      pieInstance.off('mouseout');
    };
  }, [chartData]);
  var option = {
    title: {
      text: chartData.title.text,
      show: showTitle
    },
    tooltip: {
      trigger: 'item',
      formatter: '{a} <br/>{b}: {c} ({d}%)'
    },
    legend: (_legend = {
      top: 'bottom',
      type: 'scroll',
      orient: 'vertical',
      right: '10%'
    }, _defineProperty(_legend, "top", 'center'), _defineProperty(_legend, "itemGap", 15), _defineProperty(_legend, "selectedMode", false), _defineProperty(_legend, "icon", 'pin'), _defineProperty(_legend, "textStyle", {
      fontSize: 14,
      rich: {
        name: {
          color: '#262A30'
        },
        value: {
          padding: [0, 5, 0, 5]
        },
        percent: {
          color: '#00A9FF'
        }
      }
    }), _defineProperty(_legend, "formatter", function formatter(name) {
      var total = (0, _utils.summate)(chartData.series[0].data);
      var res = chartData.series[0].data.filter(function (v) {
        return v.name === name;
      });
      var percent = (res[0].value * 100 / total).toFixed(2);
      return '{name| ' + name + '} {value|' + res[0].value + '} {percent|' + percent + '%}';
    }), _legend),
    toolbox: {
      show: false
    },
    series: [{
      name: chartData.series.length ? chartData.series[0].name : '',
      type: 'pie',
      radius: radius,
      selectedMode: 'single',
      // center: ['50%', '60%'],
      data: chartData.series.length ? chartData.series[0].data : [],
      emphasis: {
        label: {
          show: true,
          fontSize: 20,
          fontWeight: 'bold',
          formatter: '{per|{d}%}\n{name|{b}}',
          textStyle: {
            rich: {
              per: {
                fontSize: 18,
                color: '#959BA3',
                lineHeight: 30
              },
              name: {
                fontSize: 14,
                fontWeight: 'normal',
                color: '#41A6FE'
              }
            }
          }
        }
      },
      labelLine: {
        show: false
      },
      label: {
        formatter: '{b} {d}% \n',
        show: false,
        padding: [0, 0],
        position: 'center'
      }
    }]
  };

  if (!chartData.series.length) {
    return /*#__PURE__*/_react["default"].createElement(_Empty["default"], {
      image: _Empty["default"].PRESENTED_IMAGE_SIMPLE
    });
  }

  return /*#__PURE__*/_react["default"].createElement(_core["default"], _extends({
    echarts: _echarts["default"],
    notMerge: true,
    option: option
  }, rest, {
    ref: pieRef
  }));
};

PieChart.propTypes = {
  theme: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  radius: _propTypes["default"].array,
  showTitle: _propTypes["default"].bool,
  style: _propTypes["default"].object,
  className: _propTypes["default"].string,
  chartData: _propTypes["default"].object
};
PieChart.defaultProps = {
  style: {},
  classname: '',
  theme: 'macarons',
  showTitle: false,
  radius: ['35%', '60%'],
  chartData: {
    title: {
      text: ''
    },
    series: [{
      center: ['25%', '30%'],
      data: [{
        value: 335,
        name: '直接访问'
      }, {
        value: 310,
        name: '邮件营销'
      }, {
        value: 234,
        name: '联盟广告'
      }, {
        value: 135,
        name: '视频广告'
      }, {
        value: 1548,
        name: '搜索引擎'
      }]
    }]
  }
};
var _default = PieChart;
exports["default"] = _default;